#include <Windows.h>
#include <iostream>
using namespace std; 

int main () { 

    HANDLE process = GetCurrentProcess(); 

    DWORD_PTR processAffinityMask;
    DWORD_PTR systemAffinityMask;

    if (!GetProcessAffinityMask(process, &processAffinityMask, &systemAffinityMask))
        return -1;

    cout << "proc: " << processAffinityMask << "; sys: " << systemAffinityMask << ";\n";

    int core = 2; /* set this to the core you want your process to run on */
    DWORD_PTR mask=0x1;
    for (int bit=0, currentCore=1; bit < 64; bit++)
    {
        if (mask & processAffinityMask)
        {
            if (currentCore != core)
            {
                processAffinityMask &= ~mask;
            }
            currentCore++;
        }
        mask = mask << 1;
    }

    BOOL success = SetProcessAffinityMask(process, processAffinityMask); 

    cout << success << endl; 

    if (!GetProcessAffinityMask(process, &processAffinityMask, &systemAffinityMask))
        return -2;
    cout << "proc: " << processAffinityMask << "; sys: " << systemAffinityMask << ";\n";

    return 0; 

} 